-- TODO: lifes
-- also also do colorization better what you did sucks
-- also fix the pizza portal animation making mimic appear twice 

freeslot("sfx_mimicg", "sfx_mimicf", "sfx_mimice", "sfx_mimico", "sfx_mimicr", "sfx_mimicu", "sfx_mimicx")

sfxinfo[sfx_mimicg].caption = "Energy shoot"
sfxinfo[sfx_mimicf].caption = "\x85" .. "Not enough energy!" .. "\x80"
sfxinfo[sfx_mimicf].flags = SF_TOTALLYSINGLE
sfxinfo[sfx_mimice].caption = "\x83" .. "Energy get" .. "\x80"
sfxinfo[sfx_mimice].flags = SF_TOTALLYSINGLE
sfxinfo[sfx_mimico].caption = "\x85" .. "OVERCHARGING!" .. "\x80"
sfxinfo[sfx_mimico].flags = SF_TOTALLYSINGLE
sfxinfo[sfx_mimicr].caption = "\x85" .. "Floor dangerous!" .. "\x80"
sfxinfo[sfx_mimicr].flags = SF_TOTALLYSINGLE
sfxinfo[sfx_mimicu].caption = "\x85" .. "uh oh" .. "\x80"
sfxinfo[sfx_mimicx].caption = "\x85" .. "Mimic explodes" .. "\x80"

local OVERCHARGE_MAX = 150
local ENERGY = {
	max = 200*FU,
	gain = {
		natural = 1*FU/3,
		ring = 4*FU,
		enemy = 20*FU,
		electric = 2*FU,
		roll = FU/70,
		cheer = 125*FU -- elfilin
	},
	cost = {
		dashmode = 1*FU/4,
		thok = 20*FU,
		hover = FU/2,
		fly = FU/2, -- note that this stacks on hover, and is per FU of momz gained
		dangerbounce = 6*FU,
		hammer = 35*FU
	}
}

local FUME_SKINCOLORS =
{
	SKINCOLOR_ICY,
	SKINCOLOR_SKY,
	SKINCOLOR_CYAN,
	SKINCOLOR_WAVE,
	SKINCOLOR_TEAL,
	SKINCOLOR_AQUA,
	SKINCOLOR_SEAFOAM,
	SKINCOLOR_MINT,
	SKINCOLOR_PERIDOT,
	SKINCOLOR_LIME,
	SKINCOLOR_YELLOW,
	SKINCOLOR_SANDY,
	SKINCOLOR_GOLD,
	SKINCOLOR_APRICOT,
	SKINCOLOR_SUNSET
}

-- hooooooo boy this is long
-- hope chatgpt converted this properly
local function P_DoTailsOverlay(player, tails)
	local playermo = player.mimicdata.disp
	local panim = PA_ETC
	local state = playermo.state
	if state == S_PLAY_STND or state == S_PLAY_WAIT or state == S_PLAY_NIGHTS_STAND then
		panim = PA_IDLE
	elseif state == S_PLAY_EDGE then
		panim = PA_EDGE
	elseif state == S_PLAY_WALK or state == S_PLAY_SKID or state == S_PLAY_FLOAT then
		panim = PA_WALK
	elseif state == S_PLAY_RUN or state == S_PLAY_FLOAT_RUN then
		panim = PA_RUN
	elseif state == S_PLAY_DASH then
		panim = PA_DASH
	elseif state == S_PLAY_PAIN or state == S_PLAY_STUN then
		panim = PA_PAIN
	elseif state == S_PLAY_ROLL or state == S_PLAY_NIGHTS_ATTACK then
		panim = PA_ROLL
	elseif state == S_PLAY_JUMP then
		panim = PA_JUMP
	elseif state == S_PLAY_SPRING then
		panim = PA_SPRING
	elseif state == S_PLAY_FALL or state == S_PLAY_NIGHTS_FLOAT then
		panim = PA_FALL
	elseif state == S_PLAY_FLY or state == S_PLAY_FLY_TIRED or state == S_PLAY_SWIM or state == S_PLAY_GLIDE or
		   state == S_PLAY_BOUNCE or state == S_PLAY_BOUNCE_LANDING or state == S_PLAY_TWINSPIN then
		panim = PA_ABILITY
	elseif state == S_PLAY_SPINDASH or state == S_PLAY_FIRE or state == S_PLAY_FIRE_FINISH or state == S_PLAY_MELEE or
		   state == S_PLAY_MELEE_FINISH or state == S_PLAY_MELEE_LANDING then
		panim = PA_ABILITY2
	elseif state == S_PLAY_RIDE then
		panim = PA_RIDE
	else
		panim = PA_ETC
	end
    -- init...
    local smilesonground = P_IsObjectOnGround(player.mo)
    local horizangle = player.drawangle
    local zoffs = 0
    local backwards = -FRACUNIT
    local doswim = (panim == PA_ABILITY and (player.mo.eflags & MFE_UNDERWATER))
    local doroll = (panim == PA_ROLL or (panim == PA_JUMP and not (player.charflags & SF_NOJUMPSPIN)) or doswim)
    local rollangle = nil
    local panimchange = nil
    local ticnum = 0
    local chosenstate = nil

	if not tails and tails.valid then return end

    if not tails.skin then
        tails.skin = "tails"
        tails.state = S_TAILSOVERLAY_STAND
        tails.movecount = -1
    end

    panimchange = (tails.movecount ~= panim)

    -- initial position...
    if doroll then
        local testval, zdist
        if player.speed < FRACUNIT then
            testval = FRACUNIT
        else
            testval = FixedMul(player.speed, cos((horizangle - R_PointToAngle2(0, 0, player.rmomx, player.rmomy))))
            if testval < FRACUNIT then
                testval = FRACUNIT
            end
        end

        if doswim then
            zdist = player.mo.momz << 1
        elseif smilesonground and not playermo.reactiontime == 0 then
            zdist = playermo.z - tails.threshold
        else
            zdist = player.mo.momz
        end

        rollangle = R_PointToAngle2(0, 0, testval, -P_MobjFlip(playermo) * zdist)

        if not doswim then
            zoffs = 3 * FRACUNIT + 12 * sin(rollangle)
            backwards = -12 * cos(rollangle)
        end
    elseif panim == PA_RUN then
        backwards = -5 * FRACUNIT
    elseif panim == PA_SPRING or panim == PA_JUMP then
        zoffs = zoffs + 4 * FRACUNIT
        backwards = backwards / 2
    elseif panim == PA_PAIN then
        backwards = backwards / 16
    elseif playermo.state == S_PLAY_GASP then
        backwards = backwards / 16
        zoffs = zoffs + 12 * FRACUNIT
    elseif playermo.state == S_PLAY_EDGE then
        backwards = backwards / 16
        zoffs = 3 * FRACUNIT
    elseif panim == PA_ABILITY2 then
        zoffs = -7 * FRACUNIT
        backwards = -9 * FRACUNIT
    elseif panim == PA_ABILITY then
        backwards = -5 * FRACUNIT
    end

    -- sprite...
    if doroll then
        local add = (rollangle > ANGLE_180 and 2 or 0)
        if add then
            rollangle = InvAngle(rollangle)
        end
        rollangle = rollangle + ANG15 -- modify the thresholds to be nice clean numbers
        if rollangle > ANG60 then
            chosenstate = S_TAILSOVERLAY_PLUS60DEGREES + add
        elseif rollangle > ANG30 then
            chosenstate = S_TAILSOVERLAY_PLUS30DEGREES + add
        else
            chosenstate = S_TAILSOVERLAY_0DEGREES
        end
    elseif panim == PA_SPRING or panim == PA_JUMP then
        chosenstate = S_TAILSOVERLAY_MINUS60DEGREES
    elseif panim == PA_FALL or playermo.state == S_PLAY_RIDE then
        chosenstate = S_TAILSOVERLAY_PLUS60DEGREES
    elseif panim == PA_PAIN then
        chosenstate = S_TAILSOVERLAY_PAIN
    elseif playermo.state == S_PLAY_GASP then
        chosenstate = S_TAILSOVERLAY_GASP
    elseif playermo.state == S_PLAY_EDGE then
        chosenstate = S_TAILSOVERLAY_EDGE
    elseif panim == PA_DASH then
        chosenstate = S_TAILSOVERLAY_DASH
    elseif panim == PA_RUN then
        chosenstate = S_TAILSOVERLAY_RUN
    elseif panim == PA_WALK then
        if not smilesonground or playermo.state == S_PLAY_SKID then
            chosenstate = S_TAILSOVERLAY_PLUS30DEGREES
        elseif player.speed >= FixedMul(player.runspeed / 2, playermo.scale) then
            chosenstate = S_TAILSOVERLAY_0DEGREES
        else
            chosenstate = S_TAILSOVERLAY_MINUS30DEGREES
        end
    elseif playermo.sprite2 == SPR2_FLY then
        chosenstate = S_TAILSOVERLAY_FLY
    elseif playermo.sprite2 == SPR2_SWIM then
        chosenstate = S_TAILSOVERLAY_FLY
    elseif playermo.sprite2 == SPR2_TIRE then
        chosenstate = S_TAILSOVERLAY_TIRE
    elseif panim == PA_ABILITY2 then
        chosenstate = S_TAILSOVERLAY_PLUS30DEGREES
    elseif panim == PA_IDLE then
        chosenstate = S_TAILSOVERLAY_STAND
    elseif playermo.state == S_PLAY_GLIDE then
        chosenstate = S_TAILSOVERLAY_PLUS30DEGREES
    elseif playermo.state == S_PLAY_CLING or playermo.state == S_PLAY_CLIMB then
        chosenstate = S_TAILSOVERLAY_MINUS30DEGREES
    else
        chosenstate = S_INVISIBLE
    end

    -- state...
    if panimchange then
        tails.sprite2 = states[chosenstate].frame & FF_FRAMEMASK
        tails.state = chosenstate
    else
        if tails.state ~= chosenstate then
            if states[chosenstate].sprite == SPR_PLAY then
                tails.sprite2 = states[chosenstate].frame & FF_FRAMEMASK
            end
            tails.state = chosenstate
			tails.frame = $ & ~FF_FRAMEMASK
        end
    end

    -- animation...
    if panim == PA_SPRING or panim == PA_FALL or playermo.state == S_PLAY_RIDE then
        if FixedDiv(abs(player.mo.momz), player.mo.scale) < 20 << FRACBITS then -- real p.ayer.mo here cuz the overlay haz no momz
            ticnum = 2
        else
            ticnum = 1
        end
    elseif panim == PA_PAIN then
        ticnum = 2
    elseif playermo.state == S_PLAY_GASP then
        tails.tics = -1
    elseif playermo.sprite2 == SPR2_TIRE then
        ticnum = (doswim and 2 or 4)
    elseif panim ~= PA_IDLE then
        ticnum = playermo.tics
    end

    if ticnum and tails.tics > ticnum then
        tails.tics = ticnum
    end

    -- final handling...
	tails.color = FUME_SKINCOLORS[(player.dashmode * #FUME_SKINCOLORS) / (DASHMODE_MAX + 1) + 1]
	tails.colorized = true
    tails.threshold = playermo.z
    tails.movecount = panim
    tails.angle = horizangle
    P_SetScale(tails, playermo.scale)
    tails.destscale = playermo.destscale
    tails.radius = playermo.radius
    tails.height = playermo.height
    zoffs = FixedMul(zoffs, tails.scale)

    if playermo.eflags & MFE_VERTICALFLIP then
        tails.eflags = tails.eflags | MFE_VERTICALFLIP
        tails.flags2 = tails.flags2 | MF2_OBJECTFLIP
        zoffs = playermo.height - tails.height - zoffs
    else
        tails.eflags = tails.eflags & ~MFE_VERTICALFLIP
        tails.flags2 = tails.flags2 & ~MF2_OBJECTFLIP
    end

    P_MoveOrigin(
		tails,
		playermo.x + P_ReturnThrustX(tails, tails.angle, FixedMul(backwards, tails.scale)),
		playermo.y + P_ReturnThrustY(tails, tails.angle, FixedMul(backwards, tails.scale)),
		playermo.z + zoffs
	)

    if playermo.flags2 & MF2_SHADOW then
        tails.flags2 = tails.flags2 | MF2_SHADOW
    else
        tails.flags2 = tails.flags2 & ~MF2_SHADOW
    end
       
	--tails.sprite2 = states[chosenstate].frame & FF_FRAMEMASK
	tails.frame = ($ & FF_FRAMEMASK) | (playermo.frame & ~FF_FRAMEMASK)
	
	--tails.frame = 0
	--print(tails.frame, tails.sprite2 - SPR2_TAL0, tails.sprite2, tails.flags2 & MF2_DONTDRAW)
end


local function isready(p) 
	if p.pstate == PST_DEAD then return false end
	if not p.mo then return false end
	if p.mo.state == S_PLAY_DEAD then return false end
	if p.powers[pw_carry] then return false end
	if P_PlayerInPain(p) then return false end
	if p.exiting then return false end
	
	return true
end

local function tryUseEnergy(p, energy, silent, dontActuallyUse)
	if p.mimicdata.energy >= energy then
		if not dontActuallyUse then
			p.mimicdata.energy = $ - energy
		end
		return true
	else
		if p.mimicdata.energyUseFail and p.mimicdata.energyUseFail.time == 6 then
			p.mimicdata.energyUseFail.energy = max($, energy)
		else
			p.mimicdata.energyUseFail = {
				energy = energy,
				time = 6
			}
			if not silent then S_StartSound(nil, sfx_mimicf, p) end
		end
		return false
	end
end

local function startHover(player)
	player.pflags = $ & ~(PF_JUMPED|PF_SPINNING)
	player.pflags = $ | PF_NOJUMPDAMAGE
	if player.dashmode >= DASHMODE_THRESHOLD
		player.mo.state = S_PLAY_DASH
	else
		player.mo.state = S_PLAY_FLOAT_RUN
	end
	player.mimicdata.hovering = true
end

local function thok(player) -- player instead of p cuz its ported C and i dont wanna change all the "player" to "p"
	local actionspd = 60*FU
	
	if (player.charflags & SF_DASHMODE)
		actionspd = max(actionspd, FixedDiv(player.speed, player.mo.scale))
	end
	
	if (player.mo.eflags & MFE_UNDERWATER)
		actionspd = $ / 2
	end

	P_InstaThrust(player.mo, player.mo.angle, FixedMul(actionspd, player.mo.scale));
	
	
	if (maptol & TOL_2D)
		player.mo.momx = $/2;
		player.mo.momy = $/2;
	end
	
	player.drawangle = player.mo.angle

	if (not player.spectator)
		S_StartSound(player.mo, sfx_thok); // Play the THOK sound
	end
	
	player.pflags = $ | PF_THOKKED
	--player.mo.state = S_PLAY_JUMP
	--dont bother with state, a thok always leads into a hover

	local ghost = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_THOK)
	
	ghost.color = player.skincolor
	P_SetOrigin(ghost, ghost.x, ghost.y, ghost.z)
end

addHook("AbilitySpecial", function (p)
	if not (p.mo and p.mo.valid and p.mo.skin == "mimic" and p.mimicdata) then
		return
	end
	
	if not isready(p) then return true end
	
	if p.mimicdata.jumpisfake then return true end
	
	if not (p.pflags & PF_THOKKED) and tryUseEnergy(p, ENERGY.cost.thok) and not (p.cmd.buttons & BT_CUSTOM1) then
		p.mimicdata.currentskin = "sonic"
		thok(p)
	end
	if tryUseEnergy(p, ENERGY.cost.hover, true) then
		p.mimicdata.currentskin = "metalsonic"
		startHover(p)
	end
	
	return true
end)



addHook("PreThinkFrame", function ()
	for p in players.iterate do
		local realbuttons = p.cmd.buttons
		if p and p.mo and p.mo.skin == "mimic" and p.mimicdata then
			if p.mo.state == S_PLAY_BOUNCE
			or p.mo.state == S_PLAY_BOUNCE_LANDING then
				if (p.cmd.buttons & BT_JUMP) and not (p.lastcmd.buttons & BT_JUMP) then
					p.pflags = $ & ~PF_JUMPDOWN
					p.mimicdata.jumpisfake = false
				elseif p.cmd.buttons & BT_SPIN then
					p.cmd.buttons = $ | BT_JUMP
					p.mimicdata.jumpisfake = true
				else
					p.mimicdata.jumpisfake = false
				end
				p.pflags = $ & ~PF_SPINNING
			else
				p.mimicdata.jumpisfake = false
			end
			p.mimicdata.hug = nil
		end
	end
end)

addHook("MobjThinker", function (mo)
	if mo.state == S_ROSY_HUG and mo.target and mo.target.valid and mo.target.player then
		local p = mo.target.player
		if p.valid and p.mo and p.mo.valid and p.mo.skin == "mimic" and p.mimicdata then
			p.mimicdata.hug = mo
		end
	end
end, MT_ROSY)

addHook("PostThinkFrame", function ()
	for p in players.iterate do
		p.lastcmd = {buttons = p.cmd.buttons}
	end
end)

addHook("PlayerSpawn", function (p)
	p.mimicdata = nil
end)

local function maxSkinNum()
	for i=6,31 do
		if not skins[i] then
			return i-1
		end
	end
	return 31
end

addHook("PlayerThink", function (p)
	if not (p.mo and p.mo.valid and p.mo.skin == "mimic" and p.playerstate ~= PST_REBORN) then
		if p.mimicdata then
			p.mo.spritexscale = FU
			if p.mimicdata.disp.valid then
				P_RemoveMobj(p.mimicdata.disp)
			end
			if p.mimicdata.tails.valid then
				P_RemoveMobj(p.mimicdata.tails)
			end
		end
		p.mimicdata = nil
		return
	end
	
	local cmd = p.cmd
	local ready = isready(p)
	
	local onground = P_IsObjectOnGround(p.mo)
	
	if not p.mimicdata then
		p.mimicdata = {
			energy = ENERGY.max,
			overcharge = 0,
			currentskin = "metalsonic",
			deathanim = nil
		}
	end
	local mimic = p.mimicdata
	if not (mimic.disp and mimic.disp.valid) then
		mimic.disp = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_OVERLAY)
		mimic.disp.target = p.mo
		mimic.disp.state = S_INVISIBLE
		mimic.disp.skin = mimic.currentskin
		mimic.disp.colorized = true
	end
	if not (mimic.tails and mimic.tails.valid) then
		mimic.tails = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_TAILSOVERLAY);
	end
	
	p.mo.spritexscale = 0
	
	if (p.pflags & PF_STARTDASH) and (
		mimic.currentskin == "fang" or
		mimic.currentskin == "amy"
	) then
		mimic.currentskin = "sonic"
	end
	
	if not p.lastcmd then
		p.lastcmd = {
			buttons = 0
		}
	end
	
	if p.dashmode >= DASHMODE_THRESHOLD then
		mimic.energy = $ - ENERGY.cost.dashmode
	end
	
	mimic.energy = $ + ENERGY.gain.natural
	
	if mimic.overcharge > 0 then
		mimic.overcharge = $ - 1
		mimic.energy = $ + ENERGY.gain.electric/5
		local rdfu = p.mo.radius/p.mo.scale
		P_SpawnMobjFromMobj(
			p.mo,
			P_RandomRange(-rdfu, rdfu)*FU,
			P_RandomRange(-rdfu, rdfu)*FU,
			P_RandomRange(0, p.mo.height/p.mo.scale)*FU,
			MT_WATERZAP
		)
	end
	
	p.pflags = $ & ~PF_GLIDING
	
	-- DEBUG
-- 	if cmd.buttons & BT_CUSTOM1 then
-- 		mimic.currentskin = "amy"
-- 	end
-- 	if cmd.buttons & BT_CUSTOM2 then
-- 		mimic.currentskin = "knuckles"
-- 	end
	
	--hover
	if mimic.hovering and (not ready or (onground) or not (cmd.buttons & BT_JUMP) or not tryUseEnergy(p, ENERGY.cost.hover) or p.climbing) then
		mimic.hovering = false
		p.pflags = $ & ~PF_JUMPED
	end
	if mimic.hovering then
		local potentialmomz = max(0, P_MobjFlip(p.mo)*p.mo.momz)
		if (p.speed < 10*p.mo.scale)
			potentialmomz = $ + (p.speed - 10*p.mo.scale)/5
		end
		
		local tailsmomz = min(8*FU, max(0, P_MobjFlip(p.mo)*p.mo.momz+2*FU))
		local tailscost = max(0, FixedMul(tailsmomz-potentialmomz, ENERGY.cost.fly))
		
		if cmd.buttons & BT_SPIN and tryUseEnergy(p, tailscost, (p.lastcmd.buttons & (BT_SPIN|BT_JUMP))==(BT_SPIN+BT_JUMP)) then
			if not mimic.flightsounddelay then
				S_StartSound(p.mo, sfx_putput)
				mimic.flightsounddelay = 10

			end
			
			potentialmomz = tailsmomz
			
			p.mo.momx = 30*$/31
			p.mo.momy = 30*$/31
			
			mimic.currentskin = "tails"
			p.mo.state = S_PLAY_FLY
		elseif cmd.buttons & BT_CUSTOM1 then
			mimic.currentskin = "knuckles"
			p.mo.state = S_PLAY_GLIDE
			p.pflags = $ | PF_GLIDING
		else
			if p.dashmode >= DASHMODE_THRESHOLD
				p.mo.state = S_PLAY_DASH
			else
				p.mo.state = S_PLAY_FLOAT_RUN
			end
			mimic.currentskin = "metalsonic"
		end
		
		if (P_MobjFlip(p.mo)*p.mo.momz < potentialmomz)
			p.mo.momz = P_MobjFlip(p.mo)*potentialmomz;
		end
		p.pflags = $ & ~(PF_SPINNING)
		p.pflags = $ | PF_JUMPED | PF_NOJUMPDAMAGE
	else
		--bounce
		if
			not onground and cmd.buttons & BT_SPIN and ready
			and p.mo.state ~= S_PLAY_BOUNCE_LANDING
			and not (p.pflags & PF_BOUNCING) and not p.climbing
			--and tryUseEnergy(p, ENERGY.cost.bounce, (p.lastcmd.buttons & BT_SPIN), true)
		then
			p.pflags = $ & ~(PF_JUMPED|PF_NOJUMPDAMAGE|PF_SPINNING);
			p.pflags = $ | PF_BOUNCING
			mimic.currentskin = "fang"
			p.mo.state = S_PLAY_BOUNCE
		elseif
			cmd.buttons & BT_CUSTOM1 and ready and p.mo.state ~= S_PLAY_TWINSPIN
			and p.mo.state ~= S_PLAY_MELEE and p.mo.state ~= S_PLAY_MELEE_FINISH
			and p.mo.state ~= S_PLAY_MELEE_LANDING
			and not (p.pflags & PF_BOUNCING) and not p.climbing
			and not (p.lastcmd.buttons & BT_CUSTOM1)
			and not (p.pflags & PF_THOKKED)
			and tryUseEnergy(p, ENERGY.cost.hammer)
		then
			if onground then
				-- get off the ground
				P_MoveOrigin(p.mo, p.mo.x, p.mo.y, p.mo.z + P_MobjFlip(p.mo))
				
				-- hop
				-- 2*FU is amy's mindash
				P_SetObjectMomZ(p.mo, 2*FU, false);
				if (P_MobjFlip(p.mo)*p.mo.pmomz > 0) then
					p.mo.momz = $ + p.mo.pmomz; // Add the platform's momentum to your jump.
				else
					p.mo.pmomz = 0;
				end
				
				if (p.mo.eflags & MFE_UNDERWATER) then
					p.mo.momz = $ / 2;
				end
				
				-- 6*FU is amy's maxdash
				if (p.speed < FixedMul(6*FU, p.mo.scale)) then
					if (p.panim == PA_IDLE) then
						p.drawangle = p.mo.angle;
					end
					P_InstaThrust(p.mo, p.drawangle, FixedMul(6*FU, p.mo.scale));
				end
				p.mo.momx = $ + p.cmomx;
				p.mo.momy = $ + p.cmomy;
				p.mo.state = S_PLAY_MELEE
				S_StartSound(p.mo, sfx_s3k42);
			else
				p.pflags = $ & ~(PF_NOJUMPDAMAGE|PF_SPINNING);
				p.pflags = $ | P_GetJumpFlags(p) | PF_THOKKED;
				S_StartSound(p.mo, sfx_s3k42);
				p.mo.frame = 0;
				p.mo.state = S_PLAY_TWINSPIN;
			end
			mimic.currentskin = "amy"
		end
		if
			p.mo.state == S_PLAY_FLY or
			p.mo.state == S_PLAY_GLIDE
		then
			p.mo.state = S_PLAY_JUMP
		end
	end
	
	if p.mo.state == S_PLAY_BOUNCE_LANDING then
		p.pflags = $ & ~PF_SPINNING
		mimic.needsrethok = true
		if not p.currentlyLanding then
-- 			if p.mimicdata.energy < ENERGY.cost.bounce then
-- 				S_StartSound(nil, sfx_mimicf, p)
-- 				p.pflags = $ & ~PF_BOUNCING
-- 				--p.mo.state = S_PLAY_SPRING
-- 				p.mo.momz = $ / 6
-- 			else
-- 				p.mimicdata.energy = $ - ENERGY.cost.bounce
-- 			end
			P_MoveOrigin(p.mo, p.mo.x, p.mo.y, p.mo.z-P_MobjFlip(p.mo))
		end
		p.currentlyLanding = true
	else
		if not (p.pflags & PF_BOUNCING) and mimic.needsrethok
			mimic.needsrethok = nil
			p.pflags = $ & ~PF_THOKKED
		end
		p.currentlyLanding = false
	end
	
	--roll
	if p.pflags & PF_SPINNING and P_IsObjectOnGround(p.mo) then
		mimic.energy = $ + FixedMul(p.speed, ENERGY.gain.roll)
	end
	
	if (p.elfride)
	and (p.elfride.cheerdur)
		if p.elfride.cheerdur >= 5*TICRATE then
			mimic.energy = $ + ENERGY.gain.cheer
		end
		if p.elfride.cheerdur > 4*TICRATE then
			local sparks = (p.elfride.cheerdur - 4*TICRATE)/8 + 1
			local rdfu = p.mo.radius/p.mo.scale
			for i=1,sparks do
				local spark = P_SpawnMobjFromMobj(
					p.mo,
					P_RandomRange(-rdfu, rdfu)*FU,
					P_RandomRange(-rdfu, rdfu)*FU,
					P_RandomRange(0, p.mo.height/p.mo.scale)*FU,
					MT_WATERZAP
				)
				spark.colorized = true
				spark.color = SKINCOLOR_GREEN
			end
		end
	end
	
	if mimic.energy < 0 then
		if p.dashmode >= DASHMODE_THRESHOLD then
			p.dashmode = 0
			p.normalspeed = skins[p.skin].normalspeed; // Reset to default if not capable of entering dash mode.
			p.jumpfactor = skins[p.skin].jumpfactor;
			if p.powers[pw_strong] & STR_DASH then
				p.powers[pw_strong] = STR_NONE
			end
		end
		S_StartSound(p.mo, sfx_kc65)
	end
	
	mimic.energy = max(0, min($, ENERGY.max))
	
	if mimic.energyUseFail then
		mimic.energyUseFail.time = $ - 1
		if mimic.energyUseFail.time <= 0 then
			mimic.energyUseFail = nil
		end
	end
	if mimic.flightsounddelay then
		mimic.flightsounddelay = $ - 1
	end
	
	if p.mo.state == S_PLAY_BOUNCE or p.mo.state == S_PLAY_BOUNCE_LANDING then
		p.powers[pw_strong] = STR_BOUNCE
	elseif p.mo.state == S_PLAY_FLY then
		p.powers[pw_strong] = STR_UPPER
	elseif p.mo.state == S_PLAY_GLIDE or p.mo.state == S_PLAY_GLIDE_LANDING then
		p.powers[pw_strong] = STR_GLIDE
	elseif p.mo.state == S_PLAY_TWINSPIN then
		p.powers[pw_strong] = STR_TWINSPIN
	elseif p.mo.state == S_PLAY_MELEE or p.mo.state == S_PLAY_MELEE_FINISH then
		p.powers[pw_strong] = STR_MELEE
	else
		p.powers[pw_strong] = STR_NONE
	end
	if p.dashmode >= DASHMODE_THRESHOLD then
		p.powers[pw_strong] = $ | STR_METAL
	end
	
	
	local amy = false
	-- ability
	if p.pflags & PF_BOUNCING then
		p.charability = CA_BOUNCE
		p.charability2 = CA2_SPINDASH
	elseif p.mo.state == S_PLAY_GLIDE or p.mo.state == S_PLAY_GLIDE_LANDING or p.climbing then
		p.charability = CA_GLIDEANDCLIMB
		p.charability2 = CA2_SPINDASH
	elseif p.mo.state == S_PLAY_TWINSPIN or p.mo.state == S_PLAY_MELEE
		or p.mo.state == S_PLAY_MELEE_FINISH or p.mo.state == S_PLAY_MELEE_LANDING
	then
		p.charability = CA_TWINSPIN
		p.charability2 = CA2_MELEE
		amy = true
	else
		p.charability = CA_NONE
		p.charability2 = CA2_SPINDASH
	end
	
	--thok/revitem and actionspd/minmaxdash
	if amy then
		p.thokitem = MT_LHRT
		p.revitem = MT_LHRT
		p.actionspeed = 6*FU
		p.mindash = 2*FU
		p.maxdash = 6*FU
	else
		p.thokitem = MT_THOK
		p.revitem = MT_NULL
		p.actionspeed = 30*FU
		p.mindash = 15*FU
		p.maxdash = 70*FU
	end
	
	--idle anim fun
	if p.mo.state == S_PLAY_WAIT then
		mimic.idleswapdelay = ($ or 0) + 1
		if mimic.idleswapdelay >= TICRATE*4 then
			mimic.idleswapdelay = 0
			local currentskin = #skins[mimic.currentskin]
			local unchanged = true
			while skins[currentskin].name == "mimic"
				or skins[currentskin].name == "anywho"
				or skins[currentskin].name == "stardust"
				or unchanged
			do
				unchanged = false
				currentskin = $ + 1
				if currentskin > 31 or not skins[currentskin] then
					currentskin = 0
				end
			end
			mimic.currentskin = skins[currentskin].name
		end
	else
		mimic.idleswapdelay = 0
	end
	
	-- mimic dies
	if p.deadtimer then
		p.mo.flags = $ & ~MF_NOCLIPHEIGHT
		--temp
		if not mimic.deathanim then
			mimic.deathanim = {
				tic = 0,
				exploded = false,
				holdz = nil
			}
			if mimic.lastdamage == DMG_CRUSHED then
				mimic.deathanim.tic = 99
			else
				S_StartSound(p.mo, sfx_mimicu)
			end
			if p.mo.state == S_PLAY_DRWN then
				p.mo.momz = 7*FRACUNIT*P_MobjFlip(p.mo)
			end
		end
		mimic.deathanim.tic = $ + 1
		if mimic.deathanim.tic >= 34 then
			if mimic.deathanim.exploded then
				P_MoveOrigin(p.mo, p.mo.x, p.mo.y, mimic.deathanim.holdz)
				p.mo.momz = 0
			else
				--play X and stop U
				S_StopSound(p.mo)
				S_StartSound(p.mo, sfx_mimicx)
				mimic.deathanim.holdz = p.mo.z
				mimic.deathanim.exploded = true
				P_FlashPal(p, PAL_INVERT, 2)
				--debris
				for _=1,16 do
					local junk = P_SpawnMobjFromMobj(p.mo, 0, 0, 0, MT_BROKENROBOT)
					junk.state = S_INVISIBLE
					junk.fuse = TICRATE*60
					junk.mimicjunk = true
					junk.sprite = SPR_PLAY
					junk.skin = "mimic"
					junk.sprite2 = SPR2_FLY
					junk.frame = P_RandomRange(0, 2)
					junk.momx = P_RandomRange(-3, 3)*FU
					junk.momy = P_RandomRange(-3, 3)*FU
					junk.momz = P_MobjFlip(junk)*P_RandomRange(0, 8)*FU
					junk.rollangle = P_RandomRange(0, 359)*ANG1
					junk.rollanglespeed = P_RandomRange(-45, 45)*ANG1
					junk.spritexscale = FixedMul($/2, P_RandomRange(FU/2, 3*FU/2 - 8))
					junk.spriteyscale = junk.spritexscale
					junk.spriteyoffset = junk.spriteyscale*8
					local rand = P_RandomByte()
					if rand < 140 then
						junk.colorized = true
						if rand < 40 then
							junk.color = FUME_SKINCOLORS[P_RandomRange(1, #FUME_SKINCOLORS)]
						else
							junk.color = mimic.disp.color
						end
					end
					junk.flags = MF_NOCLIPTHING
				end
				p.mo.fuse = 1
			end
		else
			if p.mo.momz * P_MobjFlip(p.mo) < FU*2 then
				p.mo.momz = P_MobjFlip(p.mo) * FU*2
			end
			p.deadtimer = max(2, $ - 1)
		end
	else
		mimic.deathanim = nil
	end
	
	-- momentum mod fix
	p.bouncelast = p.pflags&PF_BOUNCING
end)

addHook("MobjThinker", function (junk)
	if
		junk and junk.valid and junk.mimicjunk
	then
		if not P_IsObjectOnGround(junk) then
			junk.rollangle = $ + junk.rollanglespeed
		end
		if junk.fuse == TICRATE*2 then
			junk.flags = MF_NOCLIPHEIGHT | MF_NOCLIP
			junk.momz = 5*P_MobjFlip(junk)
			junk.rollanglespeed = 0
		end
		if junk.fuse < 10 then
			junk.frame = ($ & ~FF_TRANSMASK) | FF_TRANS10*min(9, (11-junk.fuse))
		end
	end
end, MT_BROKENROBOT)

local function spaz()
	if P_RandomRange(0, 32) ~= 0 then
		return P_RandomRange(-FU/64,FU/64)
	end
	local a = P_RandomRange(-FU/4,FU/4)
	return a
end

local FLICKER = {1,3,7,3,4,5,2}

local function getFlicker(p)
	local f = FLICKER[(leveltime + #p)%#FLICKER + 1]
	if p.powers[pw_flashing] and (leveltime % 2) then
		f = min(9, 4+$*2)
	end
	return f
end

local SKINCHANGEANIM = {
	{FU*2, FU*2},
	{3*FU/2, FU/2},
	{FU/2, 3*FU/2},
	{FU/2, FU/2},
}

local CHARCOLORMAP = {
	sonic = SKINCOLOR_BLUEBELL,
	tails = SKINCOLOR_YOGURT,
	knuckles = SKINCOLOR_PINK,
	fang = SKINCOLOR_MAUVE,
	amy = SKINCOLOR_FANCY,
	metalsonic = SKINCOLOR_HOLOGRAM
}

rawset(_G, "MIMICUTIL", {
	spaz = spaz,
	flicker = getFlicker,
	charcolors = CHARCOLORMAP
})


addHook("PostThinkFrame", function ()
	for p in players.iterate do
		local isMimic = p and p.mo and p.mo.skin == "mimic" and (p.mimicdata != nil)
		if isMimic or p.skincolor == SKINCOLOR_HOLOGRAM then
			local disp
			if isMimic then
				disp = p.mimicdata.disp
			else
				disp = p.mo
			end
			if disp and disp.valid then
				disp.spritexscale = FU + spaz()
				disp.spriteyscale = FU + spaz()
				disp.frame = ($ & ~FF_TRANSMASK) | FF_TRANS10*getFlicker(p)
				disp.colorized = true
				if p.followmobj and p.followmobj.valid then
					p.followmobj.spritexscale = disp.spritexscale
					p.followmobj.spriteyscale = disp.spriteyscale
					p.followmobj.frame = ($ & ~FF_TRANSMASK) | FF_TRANS10*getFlicker(p)
					p.followmobj.colorized = true
				end
			end
			if not isMimic then p.wasHolographic = true end
		elseif p.wasHolographic then
			p.mo.spritexscale = FU
			p.mo.spriteyscale = FU
			p.mo.colorized = false
			if p.followmobj and p.followmobj.valid then
				p.followmobj.spritexscale = FU
				p.followmobj.spriteyscale = FU
				p.followmobj.frame = 0
				p.followmobj.colorized = false
			end
		end
		if isMimic then
			-- display stuff
			local disp = p.mimicdata.disp
			if not (disp and disp.valid) then return end
			local targetState = p.mo.state
			if targetState == S_PLAY_JUMP then
				if (p.pflags & PF_NOJUMPDAMAGE) then
					if p.mo.momz * P_MobjFlip(p.mo) > 0 then
						targetState = S_PLAY_SPRING
					else
						targetState = S_PLAY_FALL
					end
				else
					targetState = S_PLAY_ROLL
				end
			end
			if p.playerstate ~= PST_LIVE and targetState ~= S_PLAY_DRWN then
				targetState = S_PLAY_DEAD
			end
			if p.mo.color == SKINCOLOR_HOLOGRAM then
				disp.color = CHARCOLORMAP[p.mimicdata.currentskin] or skins[p.mimicdata.currentskin].prefcolor
			else
				disp.color = p.mo.color
			end
			if (leveltime % 4 < 2) and (
				p.dashmode >= DASHMODE_THRESHOLD or
				(p.powers[pw_carry] == CR_NIGHTSMODE and p.mo.state == S_PLAY_NIGHTS_DRILL)
			) then
				disp.color = SKINCOLOR_KETCHUP
			end
			disp.rollangle = p.mo.rollangle
			
			local currentskin = p.mimicdata.currentskin
			if p.MIMIC_SKINLOCK and skins[p.MIMIC_SKINLOCK] then
				currentskin = skins[p.MIMIC_SKINLOCK].name
			end
			if p.mimicdata.hug and p.mimicdata.hug.valid then
				-- mimic can hug :)
				currentskin = "amy"
				targetState = S_ROSY_HUG
				disp.color = CHARCOLORMAP["amy"]
				disp.angle = R_PointToAngle2(p.mo.x, p.mo.y, p.mimicdata.hug.x, p.mimicdata.hug.y)
			end
			if currentskin ~= disp.skin then
				p.mimicdata.skinchangeanim = 3
				disp.skin = currentskin
				disp.frame = $ & ~FF_FRAMEMASK
			end
			if targetState ~= disp.state then
				local lframe = disp.frame
				disp.state = targetState
				disp.frame = ($ & ~FF_TRANSMASK) | (lframe & FF_TRANSMASK)
			end
			if disp.state == S_PLAY_SKID then
				disp.frame = $ & ~FF_FRAMEMASK
			end
			if p.mimicdata.skinchangeanim then
				local f = SKINCHANGEANIM[p.mimicdata.skinchangeanim + 1]
				disp.spritexscale = FixedMul($, f[1])
				disp.spriteyscale = FixedMul($, f[2])
				p.mimicdata.skinchangeanim = $ - 1
			end
			
			P_DoTailsOverlay(p, p.mimicdata.tails)
			local followvalid = (p.followmobj and p.followmobj.valid)
			if followvalid then
				if p.MIMIC_PERMATAILS or (currentskin == "tails") then
					p.mimicdata.tails.flags2 = $ & ~MF2_DONTDRAW
					p.followmobj.flags2 = $ | MF2_DONTDRAW
				else
					p.mimicdata.tails.flags2 = $ | MF2_DONTDRAW
					p.followmobj.flags2 = $ & ~MF2_DONTDRAW
				end
			end
			
			-- climbing: save dashmode please
			-- actually nah
-- 			if p.climbing then
-- 				-- keep it on/off
-- 				if p.dashmode >= DASHMODE_THRESHOLD then
-- 					p.dashmode = min(DASHMODE_THRESHOLD+6, $ + 3)
-- 				else
-- 					p.dashmode = max(DASHMODE_THRESHOLD-1, $ + 3)
-- 				end
-- 			end
			
			-- die
			if p.mimicdata.deathanim then
				if p.mimicdata.deathanim.exploded then
					disp.state = S_INVISIBLE
					if followvalid then
						p.followmobj.state = S_INVISIBLE
					end
				else
				    local off = p.mimicdata.deathanim.tic * FU * p.mimicdata.deathanim.tic / 12
					
					if p.mimicdata.deathanim.tic % 2 then
						off = -$
					end
					disp.spritexoffset = off
					if followvalid then
						p.followmobj.spritexoffset = off
					end
				end
			else
				disp.spritexoffset = 0
				if followvalid then
					p.followmobj.spritexoffset = 0
				end
			end
		end
	end
end)

local livesHUD = hudinfo[HUD_LIVES]

local function fillPartialMeter(v, fromenergy, toenergy, color, flags)
	local fgPatch = v.cachePatch("MIMIC_BAR_FG")
	local fromEnergyPercent = FixedDiv(fromenergy, ENERGY.max)
	local toEnergyPercent = FixedDiv(toenergy, ENERGY.max)
	v.drawCropped( -- x,y,hscale,vscale,patch,flags,color,lchop,uchop,w,h
		livesHUD.x*FU+FixedMul(fromEnergyPercent, fgPatch.width * FU), livesHUD.y*FU,
		FU, FU,
		fgPatch,
		V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM|flags,
		v.getColormap(nil, color),
		FixedMul(fromEnergyPercent, fgPatch.width * FU), 0,
		FixedMul(toEnergyPercent-fromEnergyPercent, fgPatch.width * FU),
		fgPatch.height*FU
	)
end

local function fillMeter(v, energy, color, flags)
	fillPartialMeter(v, 0, energy, color, flags)
end

local function hudTransMult(v, base)
	local hudTrans = 10-(v.localTransFlag() / V_10TRANS)
	return V_10TRANS*(10-(
		base*hudTrans/10
	))
end

local laggedEnergies = nil

local cv_cooplives = CV_FindVar("cooplives")

local function iif(c,t,f)
	if c return t else return f end
end

local function ST_drawLivesArea(v, stplyr)
    local v_colmap = V_YELLOWMAP
    local livescount
    local notgreyedout = false
	local mimicdata = stplyr.mimicdata
	if not mimicdata then
		mimicdata = {
			currentskin = "metalsonic",
			skinchangeanim = 1
		}
	end
	local transitioning = mimicdata.skinchangeanim
	
	local currentskin = mimicdata.currentskin
	if stplyr.MIMIC_SKINLOCK and skins[stplyr.MIMIC_SKINLOCK] then
		currentskin = skins[stplyr.MIMIC_SKINLOCK].name
	end

    -- face
	local facepatch = v.getSprite2Patch(currentskin, SPR2_XTRA, false, A)
	local fpscale = FU
	if transitioning then
		facepatch = v.cachePatch("MIMIC_GLITCHLIFE" .. tostring(leveltime % 3 + 1))
		fpscale = FU
	elseif skins[currentskin].flags & SF_HIRES then
		fpscale = skins[currentskin].highresscale
	end
	if FixedMul(max(facepatch.width, facepatch.height), fpscale) > 64 then
		facepatch = v.getSprite2Patch("metal", SPR2_XTRA, false, A)
		fpscale = FU
	end
	local colormap = v.getColormap(TC_RAINBOW, stplyr.skincolor)
	if mimicdata.disp and mimicdata.disp.valid then
		colormap = v.getColormap(TC_RAINBOW, mimicdata.disp.color)
	end
	if stplyr.spectator then
        colormap = v.getColormap(TC_RAINBOW, SKINCOLOR_CLOUDY)
    end
    v.drawScaled(
		livesHUD.x*FU, livesHUD.y*FU,
		FixedMul(FU/2, fpscale),
		facepatch,
		livesHUD.f | V_PERPLAYER | V_HUDTRANS,
		colormap
	)

    -- Metal Sonic recording
    if stplyr.spectator then
        v_colmap = V_GRAYMAP
    else
        local candrawlives = false

        -- Set the player's name color.
        if G_TagGametype() and (stplyr.pflags & PF_TAGIT) then
            v_colmap = V_ORANGEMAP
        elseif G_GametypeHasTeams() then
            if stplyr.ctfteam == 1 then
                v_colmap = V_REDMAP
            elseif stplyr.ctfteam == 2 then
                v_colmap = V_BLUEMAP
            end
        end

        -- Co-op and Competition, normal life counter
        if G_GametypeUsesLives() then
            -- Handle cooplives here
            if (netgame or multiplayer) and G_GametypeUsesCoopLives() and cv_cooplives.value == 3 then
                local i
                livescount = 0
                notgreyedout = (stplyr.lives > 0)
                for i = 0, MAXPLAYERS - 1 do
                    if not playeringame[i] then
                        continue
                    end

                    if players[i].lives < 1 then
                        continue
                    end

                    if players[i].lives > 1 then
                        notgreyedout = true
                    end

                    if players[i].lives == INFLIVES then
                        livescount = INFLIVES
                        break
                    elseif livescount < 99 then
                        livescount = livescount + players[i].lives
                    end
                end
            else
				livescount = iif(
					(
						(netgame or multiplayer)
						and G_GametypeUsesCoopLives() and cv_cooplives.value == 0), INFLIVES, stplyr.lives
				);
				notgreyedout = true;
            end

            candrawlives = true
        -- Infinity symbol (Race)
        elseif G_PlatformGametype() and not (gametyperules & GTR_LIVES) then
            livescount = INFLIVES
            notgreyedout = true
            candrawlives = true
        -- Otherwise nothing, sorry.
        -- Special Stages keep not showing lives,
        -- as G_GametypeUsesLives() returns false in
        -- Special Stages, and the infinity symbol
        -- cannot show up because Special Stages
        -- still have the GTR_LIVES gametype rule
        -- by default.
        end

        -- Draw the lives counter here.
        if candrawlives then
            -- x
            v.draw(
				livesHUD.x + 22,
				livesHUD.y + 10,
				v.cachePatch("stlivex"),
				livesHUD.f | V_PERPLAYER | V_HUDTRANS
			)
            if livescount == INFLIVES then
                v.drawString(
					livesHUD.x + 50,
					livesHUD.y + 8,
					"\x16",
					livesHUD.f | V_PERPLAYER | V_HUDTRANS
				)
            else
                if stplyr.playerstate == PST_DEAD and not stplyr.spectator and (livescount > 0 or stplyr.deadtimer < (TICRATE << 1)) and not (stplyr.pflags & PF_FINISHED) then
                    livescount = livescount + 1
                end
                if livescount > 99 then
                    livescount = 99
                end
                --V_DrawRightAlignedString
				v.drawString(
					livesHUD.x + 58,
					livesHUD.y + 8,
					tostring(livescount),
					livesHUD.f | V_PERPLAYER | iif(notgreyedout, V_HUDTRANS, V_HUDTRANSHALF),
					"right"
				)
            end
        else
            -- Draw team name instead of lives, if possible.
            if G_TagGametype() and (stplyr.pflags & PF_TAGIT) then
                   v.drawString(
					   livesHUD.x + 58,
					   livesHUD.y + 8,
					   "IT!",
					   V_HUDTRANS | livesHUD.f | V_PERPLAYER,
					   "right"
				   )
            elseif G_GametypeHasTeams() then
                if stplyr.ctfteam == 1 then
                   v.drawString(
					   livesHUD.x + 58,
					   livesHUD.y + 8,
					   "RED",
					   V_HUDTRANS | livesHUD.f | V_PERPLAYER,
					   "right"
				   )
                elseif stplyr.ctfteam == 2 then
                   v.drawString(
					   livesHUD.x + 58,
					   livesHUD.y + 8,
					   "BLUE",
					   V_HUDTRANS | livesHUD.f | V_PERPLAYER,
					   "right"
				   )
                end
            end
        end
    end

    -- name
	local rv_colmap = v_colmap
	local doubleflickertrans = hudTransMult(v, 10-(getFlicker(stplyr)/2))
	local halfflickertrans = hudTransMult(v, max(1, (10-getFlicker(stplyr))/2))
    v_colmap = rv_colmap | (doubleflickertrans | livesHUD.f | V_PERPLAYER)
	--mimic BG
	v.drawString(
	   livesHUD.x + 58,
	   livesHUD.y,
	   "MIMIC",
	   rv_colmap | (halfflickertrans | livesHUD.f | V_PERPLAYER),
	   "right"
    )
	local hudname = skins[currentskin].hudname
	if transitioning then
		if v.RandomKey(50) == 0 then
			hudname = ({"CLONE", "EVERYONE", "SIGSEGV", "HI MOM", "404", "SONKI", "HUH", "TAKIS"})[v.RandomKey(8) + 1]
		else
			hudname = skins[v.RandomKey(6)].hudname
		end
	end
	
	local centerWidth = v.stringWidth("MIMIC")/2
	
    if #hudname <= 5 then
        --V_DrawRightAlignedString
		--i want centered v.drawString(livesHUD.x + 58, livesHUD.y, hudname, v_colmap, "right")
		v.drawString(livesHUD.x + 18 + centerWidth, livesHUD.y, hudname, v_colmap, "center")
    elseif v.stringWidth(hudname) <= 48 then
        --V_DrawString
		v.drawString(livesHUD.x + 18, livesHUD.y, hudname, v_colmap)
    elseif v.stringWidth(hudname, 0, "thin") <= 40 then
        --V_DrawRightAlignedThinString
		v.drawString(livesHUD.x + 18 + centerWidth, livesHUD.y, hudname, v_colmap, "thin-center")
    else
        --V_DrawThinString
		v.drawString(livesHUD.x + 18, livesHUD.y, hudname, v_colmap, "thin")
    end

    -- Power Stones collected
    if G_RingSlingerGametype() and hud.enabled("powerstones") then
        local workx = livesHUD.x + 1
		local worky = livesHUD.y - 21
        local j
        if (leveltime & 1) and stplyr.powers[pw_invulnerability] and (stplyr.powers[pw_sneakers] == stplyr.powers[pw_invulnerability]) then -- hack; extremely unlikely to be activated unintentionally
            for j = 0, 6 do -- "super" indicator
                --V_DrawScaledPatch
				v.draw(
					workx,
					worky,
					v.cachePatch("TEMER" .. tostring(j+1)),
					V_HUDTRANS | livesHUD.f | V_PERPLAYER
				)
                workx = workx + 8
            end
        else
            for j = 0, 6 do -- powerstones
                if (stplyr.powers[pw_emeralds] & (1 << j)) > 0 then
					v.draw(
						workx,
						worky,
						v.cachePatch("TEMER" .. tostring(j+1)),
						V_HUDTRANS | livesHUD.f | V_PERPLAYER
					)
                end
                workx = workx + 8
            end
        end
    end
end

local wasMimic = false


hud.add(function (v, p)
	local elfilin = p.elfilin and p.elfilin.ridingplayer and p.elfilin.ridingplayer.player
	if elfilin then
		p = elfilin
	end
	--print("#", p.realmo, p.realmo.valid, p.realmo.skin == "mimic", p.powers[pw_carry] ~= CR_NIGHTSMODE)
	if not (p.realmo and p.realmo.valid and p.realmo.skin == "mimic" and p.powers[pw_carry] ~= CR_NIGHTSMODE) then
		laggedEnergies = nil
		if wasMimic then
			hud.enable("lives")
			wasMimic = false
		end
		return
	elseif not elfilin
		hud.disable("lives")
		wasMimic = true
		if leveltime > 1 then ST_drawLivesArea(v, p) end
	end
	
	local mimic = p.mimicdata
	if not (p.mo and p.mo.valid and p.mimicdata) then
		if p.spectator then
			laggedEnergies = nil
			return
		else
			if not p.mimicdata then
				if laggedEnergies then
					mimic = {energy = laggedEnergies[1], overcharge = 0}
				else
					mimic = {energy = 0, overcharge = 0}
				end
			end
		end
	end

	v.draw(
		livesHUD.x, livesHUD.y,
		v.cachePatch("MIMIC_BAR_BG"),
		V_PERPLAYER|V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_HUDTRANS,
		v.getColormap(nil, p.skincolor)
	)
	if mimic.energyUseFail then
		local newTrans = hudTransMult(v, mimic.energyUseFail.time)
		fillMeter(v, mimic.energyUseFail.energy, SKINCOLOR_FLAME, newTrans)
	end
	
	if laggedEnergies == nil then
		laggedEnergies = {mimic.energy, mimic.energy}
	else
		laggedEnergies = {
			3*$[1]/4 + mimic.energy/4,
			9*$[2]/10 + mimic.energy/10
		}
	end
	
	--DEBUG
	--mimic.energy = 160*FU
	--laggedEnergies = {mimic.energy/2, mimic.energy/3}
	
	
	if laggedEnergies[2] > mimic.energy then
		fillMeter(
			v, laggedEnergies[2],
			SKINCOLOR_APRICOT,
			hudTransMult(v, 3)
		)
	end
	if laggedEnergies[1] > mimic.energy then
		fillMeter(
			v, laggedEnergies[1],
			SKINCOLOR_ORANGE,
			hudTransMult(v, 6)
		)
	end
	
	local energyColor = SKINCOLOR_GOLD
	if mimic.overcharge > 0 and leveltime % 8 < 4 then
		energyColor = SKINCOLOR_ORANGE
	end
	fillMeter(v, mimic.energy, energyColor, V_HUDTRANS)
	if mimic.overcharge > 0 then
		fillMeter(v, mimic.overcharge*ENERGY.max/OVERCHARGE_MAX, SKINCOLOR_FLAME, hudTransMult(v, 5))
	end
	
	if laggedEnergies[2] < mimic.energy then
		fillPartialMeter(
			v, laggedEnergies[2], mimic.energy,
			SKINCOLOR_SKY,
			hudTransMult(v, 3)
		)
	end
	if laggedEnergies[1] < mimic.energy then
		fillPartialMeter(
			v, laggedEnergies[1], mimic.energy,
			SKINCOLOR_WAVE,
			hudTransMult(v, 6)
		)
	end
	
	if elfilin then
		v.drawString(
			320,
			98,
			"Cheer to refill \x84" .. p.name .. "\x80's energy!",
			V_SNAPTOTOP | V_SNAPTOLEFT | V_PERPLAYER | V_ALLOWLOWERCASE,
			"thin-right"
		)
	end
end)

local ringtypes = {
	MT_RING,
	MT_COIN,
	MT_REDTEAMRING,
	MT_BLUETEAMRING
}

local function gainEnergy(p, amount)
	local mimic = p.mimicdata
	if not mimic then return false end
	if mimic.energy >= ENERGY.max then return false end
	mimic.energy = $ + amount
	S_StartSound(p.mo, sfx_mimice)
	return true
end

for _,v in pairs(ringtypes)
	addHook("TouchSpecial", function (special, toucher)
		if
			toucher.player and toucher.player.mo and toucher.player.mo.valid
			and toucher.player.mo.skin == "mimic" and toucher.player.mimicdata
		then
			gainEnergy(toucher.player, ENERGY.gain.ring)
		end
	end, v)
end

addHook("MobjDamage", function (target, inflictor, source, damage, damagetype)
	local cause = source or inflictor
	if not cause then return end
	local p = cause.player
	if not p then return end
	if p.mo.skin ~= "mimic" or not p.mimicdata then return end
	gainEnergy(p, ENERGY.gain.enemy)
end)

addHook("ShouldDamage", function (target, inflictor, source, damage, damagetype)
	local p = target.player
	if not p then return end
	if p.mo.skin ~= "mimic" or not p.mimicdata then return end
	
	p.mimicdata.lastdamage = damagetype
	
	if damagetype == DMG_ELECTRIC then
		if not gainEnergy(p, ENERGY.gain.electric) and not (p.powers[pw_shield] & SH_PROTECTELECTRIC) then
			if p.mimicdata.overcharge < OVERCHARGE_MAX then
				p.mimicdata.overcharge = $ + 5
				if leveltime % 2 == 0 then
					S_StartSound(target, sfx_mimico, p)
				end
			else
				return nil
			end
		end
		return false
	elseif p.currentlyLanding and not p.powers[pw_invulnerability] and not p.powers[pw_flashing] then
		if tryUseEnergy(p, ENERGY.cost.dangerbounce) then
			if leveltime % 2 == 0 then
				S_StartSound(target, sfx_mimicr, p)
			end
			return false
		end
	end
end, MT_PLAYER)


