local TIPS = {
	{
		"You have limited energy! You can gain energy",
		"by rolling, collecting rings, destroying badniks,",
		"or just waiting."
	},
	{"Electric-type damage will charge you, but don't take it for too long!"},
	{"C1 alone will activate Amy's hammer. C1 while hovering glides."}
}

local tipNum = 0
local gottenTipYet = false
local tipTics = nil

addHook("MapLoad", function ()
	if not tipTics then
		gottenTipYet = false
	end
end)


addHook("ThinkFrame", function ()
	if tipTics ~= nil then
		tipTics = $ + 1
		if tipTics > TICRATE*8 then
			tipTics = nil
		end
	end
	if tipNum >= #TIPS and tipTics == nil and not MIMICCFG.seenalltips then
		MIMICCFG.seenalltips = true
		MIMICCFG.write()
	end
end)

local forceNewTip = false


hud.add(function (v)
	local p = consoleplayer
	if p.realmo and p.realmo.valid and p.realmo.skin == "mimic" then
		if tipTics then
			local easeProg = FU
			if tipTics < TICRATE then
				easeProg = tipTics * FU / TICRATE
			end
			if tipTics > TICRATE*7 then
				easeProg = (TICRATE*8 - tipTics) * FU / TICRATE
			end
			local pos = ease.outquad((min(FU, easeProg+FU/2)-FU/2)*2, 200*FU, 150*FU)
			v.drawString(160*FU, pos, "Mimic Tip:", V_SNAPTOBOTTOM, "fixed-center")
			pos = $ + 5*FU
			for i,l in ipairs(TIPS[tipNum]) do
				v.drawString(160*FU, pos+9*i*FU, l, V_ALLOWLOWERCASE|V_SNAPTOBOTTOM, "thin-fixed-center")
			end
			v.drawString(160*FU, pos+35*FU, "mimic_notips to skip these, mimic_nexttip for next", V_ALLOWLOWERCASE|V_SNAPTOBOTTOM|V_TRANSLUCENT, "thin-fixed-center")
			
		elseif (forceNewTip or not gottenTipYet) and tipNum < #TIPS then
			tipTics = 0
			tipNum = $ + 1
			gottenTipYet = true
		end
	end
end)

COM_AddCommand("mimic_notips", function(player)
	tipTics = nil
	tipNum = 999
	MIMICCFG.seenalltips = true
	MIMICCFG.write()
end, COM_LOCAL)

COM_AddCommand("mimic_nexttip", function(player)
	if tipNum >= #TIPS then
		print("You've already seen the last tip!")
		return
	end
	forceNewTip = true
	if tipTics == nil then
		--
	elseif tipTics < TICRATE then
		tipTics = TICRATE*7 + (TICRATE - $)
	elseif tipTics < TICRATE*7 then
		tipTics = TICRATE*7
	end
end, COM_LOCAL)